<?xml version="1.0"?>
<!DOCTYPE xsl:stylesheet [
<!ENTITY nbsp "&#160;">
]>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
xmlns:msxsl="urn:schemas-microsoft-com:xslt" 
xmlns:user="mynamespace" version="1.0">
<xsl:output method="html"/>


  <xsl:template match="/">
<HTML>
	<HEAD>
	<TITLE><xsl:value-of select="'Authors Example'" /></TITLE>
	</HEAD>

	<BODY>

    <xsl:call-template name="belongsTo">
		<xsl:with-param name="parmNodes" 
		select="authors/author[@period='classical']">
		</xsl:with-param>
		
		<xsl:with-param name="singleNode" 
		select="authors/author[name='Sophocles']">
		</xsl:with-param>
		
    </xsl:call-template>

    <xsl:call-template name="belongsTo">
		<xsl:with-param name="parmNodes" 
		select="authors/author[@period='classical']">
		</xsl:with-param>
		
		<xsl:with-param name="singleNode" 
		select="authors/author[name='Victor Hugo']">
		</xsl:with-param>
		
    </xsl:call-template>


	</BODY>
	</HTML>



</xsl:template>

<xsl:template name="belongsTo">
<xsl:param name="parmRoot"/>
<xsl:param name="parmNodes"/>
<xsl:param name="singleNode"/>

<xsl:variable name="isMember" select="count($parmNodes|$singleNode)-count($parmNodes)"/>

<P>Node&nbsp;&nbsp;-&nbsp;&nbsp;Set:</P>
	<xsl:for-each select="$parmNodes">
		<P ALIGN="CENTER">
		<xsl:value-of select="." /> 
		</P>
	</xsl:for-each>
	
<P>Single Node:</P>
	<xsl:for-each select="$singleNode">
		<P ALIGN="CENTER">
		<xsl:value-of select="." /> 
		</P>
	</xsl:for-each>
	
	<p>Node-set count is:
		<xsl:value-of select="count($parmNodes)" />
	</p>

	<p>Single node count is:
		<xsl:value-of select="count($singleNode)" />
	</p>
	

	<p>Union count is:
		<xsl:value-of select="count($parmNodes | $singleNode)" />
	</p>
	
	<p>count(union) - count(node-set) is:
		<xsl:value-of select="count($parmNodes | $singleNode) - count($parmNodes)" />
	</p>
	
	
	
	<p>node
	<xsl:choose>
		<xsl:when test="count($parmNodes | $singleNode) - count($parmNodes)" > is not </xsl:when>
		<xsl:otherwise> is </xsl:otherwise>
	</xsl:choose>	
	a member of nodeSet. 
	</p>
	
	<p>Variable-based membership is "<xsl:value-of select="string($isMember)"/>"</p>

</xsl:template>

<msxsl:script implements-prefix="user">
<![CDATA[ 
    function today()
    {
      return '2000-07-01'; //now();
    }
	
	function reflect(x)
	{
		return(x);
	}
  ]]> 
  </msxsl:script>
</xsl:stylesheet>

