<xsl:stylesheet version="1.0"
				xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
				xmlns:msxsl="urn:schemas-microsoft-com:xslt"
>

<xsl:output method="html"/>

<xsl:template match="/">
<HTML>
	<HEAD>
	<TITLE><xsl:value-of select="'Test Type'" /> </TITLE>
	</HEAD>
	<BODY>
		<p><xsl:text>/ is a </xsl:text>
		<xsl:call-template name="isNode-Set">
			<xsl:with-param name="pValue" select="/"/>
		</xsl:call-template>
		</p>

		<p><xsl:text>count(/*) is a </xsl:text>
		<xsl:call-template name="isNode-Set">
			<xsl:with-param name="pValue" select="count(/*)"/>
		</xsl:call-template>
		</p>
	</BODY>
	</HTML>


</xsl:template>


<xsl:template name="isNode-Set">
	<xsl:param name="pValue"/>
	
	<xsl:variable name="vContainer">
			<xsl:copy-of select="$pValue"/>
	</xsl:variable>
	
	<xsl:choose>
		<xsl:when test="count(msxsl:node-set($vContainer)/*) > 0">
				<xsl:text>Node-Set</xsl:text>
		</xsl:when>
		<xsl:otherwise>
				<xsl:text>Scalar</xsl:text>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

</xsl:stylesheet>
